<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button type="button" class="btn btn-primary ml-1" (click)="getInfo()" [disabled]="ngForm.invalid">
    <i class="fas fa-search mr-2"></i>Buscar
  </button>
  <button (click)="exportExcel()" class="btn btn-success ml-1" [disabled]="dataGrid.length == 0">
    <i class="fa fa-file-excel mr-2"></i>Excel
  </button>
  <button (click)="exportPdf()" class="btn btn-danger ml-1"  [disabled]="dataGrid.length == 0">
    <i class="fas fa-file-pdf mr-2"></i>PDF
  </button>
</app-page-title>

<div class="main-card mb-3 card">
  <div class="card-body">

    <form [formGroup]="ngForm">
      <div class="row">
        <div class="form-group col-12 col-sm-3 col-md-3 col-lg-3 col-xl-3">
          <div class="row">
            <div class="form-group col">
              <label class="w-100">Desde</label>
              <kendo-datepicker formControlName="fFec1" class="w-100"
              (valueChange)="fechaChange(1);" [max]="maxDateDesde">
              </kendo-datepicker>
            </div>
            <div class="form-group col">
              <label class="w-100">Hasta</label>
              <kendo-datepicker formControlName="fFec2" class="w-100"
              (valueChange)="fechaChange(2);" [min]="minDateHasta">
              </kendo-datepicker>
            </div>
          </div>
        </div>
        <div class="col-6">
          <div class="row">
            <div class="col-4">
              <label class="w-100">Clave</label>
                  <div class="input-group">
                    <input type="tel" pattern="[0-9]*" class="form-control" formControlName="iInt1">
                    <div class="input-group-append">
                      <button class="btn btn-primary" type="button" (click)="openModal(modal, 'telefonosClaves')">
                        <i class="fas fa-search"></i>
                      </button>
                    </div>
                  </div>
            </div>
            <div class="col-4">
              <label class="w-100">Depto.</label>
                  <div class="input-group">
                    <input type="tel" pattern="[0-9]*" class="form-control" formControlName="iInt2" readonly>
                    <div class="input-group-append">
                      <button class="btn btn-primary" type="button" (click)="openModal(modal, 'telefonosDepto')" disabled>
                        <i class="fas fa-search"></i>
                      </button>
                    </div>
                  </div>
            </div>
            <div class="col-4">
              <label class="w-100">Grupo</label>
                  <div class="input-group">
                    <input type="tel" pattern="[0-9]*" class="form-control" formControlName="iInt3" readonly>
                    <div class="input-group-append">
                      <button class="btn btn-primary" type="button" (click)="openModal(modal, 'telefonosGrupos')" disabled>
                        <i class="fas fa-search"></i>
                      </button>
                    </div>
                  </div>
            </div>
            <div class="col-12">
              <div class="form-group">
                <label class="w-100"></label>
                <input type="text"
                       [(ngModel)]="Descripcion"
                       [ngModelOptions]="{standalone: true}"
                       class="form-control"
                       readonly>
              </div>
            </div>
          </div>
        </div>

      </div>
      <div class="row">
        <div class="col-sm-4 col-md-3 col-lg-2 col-xl-2 form-group">
          <label class="w-100"></label>
          <label class="k-form-field ml-sm-2 mt-2" *ngIf="ngForm.value.iInt4 == 1">
            <input type="checkbox" id="lLog1" class="k-checkbox" formControlName="lLog1" value="false">
            <label class="k-checkbox-label" for="lLog1">Detallo Locales</label>
          </label>
          <label class="k-form-field ml-sm-2">
            <input type="checkbox" id="costo" class="k-checkbox" value="false" checked>
            <label class="k-checkbox-label" for="costo">Imprimo Costo</label>
          </label>
          <label class="k-form-field ml-sm-2">
            <input type="checkbox" id="notas" class="k-checkbox" value="false" checked>
            <label class="k-checkbox-label" for="notas">Imprimo Notas</label>
          </label>
        </div>
        <div class="col-sm-4 col-md-3 col-lg-2 col-xl-2 form-group">
          <label class="w-100 font-weight-bold">Reporte</label>
          <input type="radio" name="iInt4" formControlName="iInt4" value="1" id="detalle" class="k-radio"
          [checked]="true" (click)="changeFlag()">
          <label class="k-radio-label mr-2 w-100" for="detalle">Detallado</label>
          <input type="radio" name="iInt4" formControlName="iInt4" value="2" id="global"
          *ngIf="ngForm.value.iInt1 == 0" class="k-radio" (click)="changeFlag()">
          <label class="k-radio-label mr-2 w-100" for="global" *ngIf="ngForm.value.iInt1 == 0">Global</label>
        </div>
        <div class="col-4 form-group">
          <label>Tipo Llamada</label>
              <kendo-multiselect [data]="dsListLlamadas" [(ngModel)]="TipoLlam"
                (valueChange)="tipoLlamadaChange($event)" [ngModelOptions]="{standalone: true}"
                [textField]="'Descripcion'" [valueField]="'Descripcion'">
              </kendo-multiselect>
              <ng-template kendoMultiSelectTagTemplate let-dataItem>
                <span class="template">{{ dataItem.TipoLlam }}</span> {{ dataItem.Descripcion }}
              </ng-template>
        </div>


        <div class="col-4 form-group">
          <label>Tipo Tarifa</label>
            <div class="w-100 input-group">
              <kendo-multiselect [data]="dsListTarifas" [(ngModel)]="TipoTarif"
              (valueChange)="tipoTarifaChange($event)" [textField]="'Descripcion'"
              [valueField]="'Descripcion'" [ngModelOptions]="{standalone: true}">
              </kendo-multiselect>
              <ng-template kendoMultiSelectTagTemplate let-dataItem>
                <span class="template">{{ dataItem.TipoTarif }}</span> {{ dataItem.Descripcion }}
              </ng-template>
            </div>
        </div>

      </div>

      <div class="divider"></div>

    </form>

    <kendo-grid [kendoGridBinding]="dataGrid" *ngIf="!loading && ngForm.value.iInt4 == 1 && flag"
              [selectable]="true"
              [filter]="filter"
              [filterable]="true"
              [navigable]="true"
              [reorderable]="true"
              [resizable]="true"
              [sortable]="true"
              [pageSize]="pageSize"
              [skip]="skip"
              [pageable]="{buttonCount: 5, pageSizes: [10, 25, 50]}"
              style="height: 60vh;" class="mt-1">
              <ng-container *ngIf="dataGrid.length !== 0">
                <kendo-grid-column field="Ext" title="Código" width="90"></kendo-grid-column>
                <kendo-grid-column field="Depto" title="Depto" width="80" class="text-right"></kendo-grid-column>
                <kendo-grid-column field="Gpo" title="Grupo" width="75" class="text-right"></kendo-grid-column>
                <kendo-grid-column field="TipoLlamada" title="T" width="40"></kendo-grid-column>
                <kendo-grid-column field="Dia" title="Día" width="110" format="{0:h}">
                </kendo-grid-column>
                <kendo-grid-column field="NoFolio" title="# Folio" width="110" class="text-right"></kendo-grid-column>
                <kendo-grid-column field="Telefono" title="Teléfono" width="150"></kendo-grid-column>
                <kendo-grid-column field="Hora" title="Hora" width="70">
                </kendo-grid-column>
                <kendo-grid-column field="Cantidad" title="Cant." width="70" class="text-right"></kendo-grid-column>
                <kendo-grid-column field="Minutos" title="Min." width="70" class="text-right"></kendo-grid-column>
                <kendo-grid-column field="TotalCargo" title="Total Cargo" width="130" class="text-right">
                  <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.TotalCargo | currency:'MXN' }}
                  </ng-template>
                </kendo-grid-column>
                <kendo-grid-column field="Cxld" title="Cxld" width="70">
                  <ng-template kendoGridCellTemplate let-dataItem>
                    {{dataItem.Cxld ? 'Si' : 'No'}}
                  </ng-template>
                </kendo-grid-column>
                <kendo-grid-column field="Notas" title="Notas" width="270"></kendo-grid-column>
                <kendo-grid-column field="exten" title="Ext." width="70" class="text-right"></kendo-grid-column>
              </ng-container>
              <ng-template kendoGridNoRecordsTemplate>
                {{ noRecords }}
              </ng-template>
    </kendo-grid>


    <kendo-grid [kendoGridBinding]="dataGrid" *ngIf="!loading && ngForm.value.iInt4 == 2 && flag"
              [selectable]="true"
              [filter]="filter"
              [filterable]="true"
              [navigable]="true"
              [reorderable]="true"
              [resizable]="true"
              [sortable]="true"
              [pageSize]="pageSize"
              [skip]="skip"
              [pageable]="{buttonCount: 5, pageSizes: [10, 25, 50]}"
              style="height: 60vh;" class="mt-1">
              <ng-container *ngIf="dataGrid.length !== 0">
                <kendo-grid-column field="Ext" title="Clave" width="90"></kendo-grid-column>
                <kendo-grid-column field="TipoLlamada" title="T" width="40"></kendo-grid-column>
                <kendo-grid-column field="Depto" title="Depto" width="80" class="text-right"></kendo-grid-column>
                <kendo-grid-column field="Gpo" title="Grupo" width="75" class="text-right"></kendo-grid-column>
                <kendo-grid-column field="Dia" title="Día" width="110">
                </kendo-grid-column>
                <kendo-grid-column field="Telefono" title="Tipo de Llamada" width="150"></kendo-grid-column>
                <kendo-grid-column field="Cantidad" title="Cantidad" width="90" class="text-right"></kendo-grid-column>
                <kendo-grid-column field="Minutos" title="Min." width="110" class="text-right"></kendo-grid-column>
                <kendo-grid-column field="Costo" title="Costo" width="120">
                  <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.Costo | currency:'MXN' }}
                  </ng-template>
                </kendo-grid-column>
                <kendo-grid-column field="Total" title="Total" width="70">
                  <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.Total | currency:'MXN' }}
                  </ng-template>
                </kendo-grid-column>
              </ng-container>
              <ng-template kendoGridNoRecordsTemplate>
                {{ noRecords }}
              </ng-template>
    </kendo-grid>


    <div class="divider"></div>

    <kendo-grid [kendoGridBinding]="dataGlobal" *ngIf="!loading && flag"
              [selectable]="true"
              [filter]="filter"
              [filterable]="true"
              [navigable]="true"
              [reorderable]="true"
              [resizable]="true"
              [sortable]="true"
              [pageSize]="pageSize"
              [skip]="skip"
              [pageable]="{buttonCount: 5, pageSizes: [10, 25, 50]}"
              style="height: 60vh;" class="mt-1">
              <div *ngIf="dataGrid.length !== 0">
                <kendo-grid-column field="DescripcionTipodeLlamada" title="Tipo de Llamada" width="150"></kendo-grid-column>
                <kendo-grid-column field="Cantidad" title="Cant." width="70" class="text-right"></kendo-grid-column>
                <kendo-grid-column field="Minutos" title="Min" width="70" class="text-right"></kendo-grid-column>
                <kendo-grid-column field="Costo" title="Costo" width="100" class="text-right">
                  <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.Costo | currency:'MXN' }}
                  </ng-template>
                </kendo-grid-column>
                <kendo-grid-column field="ServicioMedido" title="Serv. Medido" width="150" class="text-right"></kendo-grid-column>
                <kendo-grid-column field="TotalCosto" title="Total Costo" width="130" class="text-right">
                  <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.TotalCosto | currency:'MXN' }}
                  </ng-template>
                </kendo-grid-column>
                <kendo-grid-column field="Cargo" title="Cargo" width="100" class="text-right" class="text-right">
                  <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.Cargo | currency:'MXN' }}
                  </ng-template>
                </kendo-grid-column>
                <kendo-grid-column field="Impuestos" title="Impuestos" width="100" class="text-right" class="text-right">
                  <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.Impuestos | currency:'MXN' }}
                  </ng-template>
                </kendo-grid-column>
                <kendo-grid-column field="TotalCargo" title="Total Cargo" width="100" class="text-right" class="text-right">
                  <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.TotalCargo | currency:'MXN' }}
                  </ng-template>
                </kendo-grid-column>
              </div>
              <ng-template kendoGridNoRecordsTemplate>
                {{ noRecords }}
              </ng-template>
    </kendo-grid>

  </div>
<app-loading *ngIf="loading"></app-loading>
</div>

<ng-template #modal let-modal let-c="close">
  <div class="modal-header">
    <h4 class="modal-title" id="modal-graf">{{ modalTitle }}</h4>
    <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">

    <app-help-telefonos-claves (telefonosClaves)="getDataModal($event, 'telefonosClaves'); c()" *ngIf="modalType === 'telefonosClaves'"></app-help-telefonos-claves>
    <app-help-telefonos-tipo-llamada (telefonosTL)="getDataModal($event, 'telefonosTL'); c()" *ngIf="modalType === 'telefonosTL'"></app-help-telefonos-tipo-llamada>
    <app-help-telefonos-tarifas (telefonosTarifas)="getDataModal($event, 'telefonosTarifas'); c()" *ngIf="modalType === 'telefonosTarifas'"></app-help-telefonos-tarifas>


  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-secondary" (click)="c('Close click')">Cerrar</button>
  </div>
</ng-template>



